// sub.cpp :
// Sub Programs for BVCM

#include "stdafx.h"
#include "sample.h"
#include "sampleDlg.h"
#include "bvcm.h"

void CsampleDlg::DispStr2Control(int id, char* str)
{
	GetDlgItem(id)->SetWindowText(str);
}

void CsampleDlg::DispInt2Control(int id, int value)
{
	char buf[12];

	if(m_Cash.i1000Y != 0)
	{
		m_Cash.i1000Y = m_Cash.i1000Y;
	}

	sprintf(buf, "%d", value);
	DispStr2Control(id, buf);
}

void CsampleDlg::ParseBvcmData1(unsigned int uiInterface, char* buf)
{
	unsigned char dc;

	if(uiInterface == BVCM_COIN)
	{
		dc = buf[1];
		switch(dc)
		{
			case 0x08:
				m_Cash.i10Y = BcdToInt(buf[2]);
				m_Cash.i50Y = BcdToInt(buf[3]);
				m_Cash.i100Y = BcdToInt(buf[4]);
				m_Cash.i500Y = BcdToInt(buf[5]);
				break;

			case 0x09:
				m_Change.i10Y = BcdToInt(buf[2]);
				m_Change.i50Y = BcdToInt(buf[3]);
				m_Change.i100Y = BcdToInt(buf[4]);
				m_Change.i500Y = BcdToInt(buf[5]);
				break;

			case 0x0A:
				m_Paid.i10Y = BcdToInt(buf[2]);
				m_Paid.i50Y = BcdToInt(buf[3]);
				m_Paid.i100Y = BcdToInt(buf[4]);
				m_Paid.i500Y = BcdToInt(buf[5]);
				break;

			case 0x0B:
				m_CoinStat = BcdToInt(buf[2]);
				break;

			case 0x0C:
				m_CoinError1 = BcdToInt(buf[2]);
				m_CoinError2 = BcdToInt(buf[3]);
				break;

			case 0x0D:
				m_CoinVersion1 = BcdToInt(buf[2]);
				m_CoinVersion2 = BcdToInt(buf[3]);
				break;
		}
	}
	else if(uiInterface == BVCM_BILL)
	{
		dc = buf[1];
		switch(dc)
		{
			case 0x18:
				m_Cash.i1000Y = BcdToInt(buf[2]);
				break;

			case 0x19:
				m_Change.i1000Y = BcdToInt(buf[2]);
				break;

			case 0x1A:
				m_Paid.i1000Y = BcdToInt(buf[2]);
				break;

			case 0x1B:
				m_BillStat1 = BcdToInt(buf[2]);
				m_BillStat2 = BcdToInt(buf[3]);
				break;

			case 0x1C:
				m_BillError = BcdToInt(buf[2]);
				break;

			case 0x1D:
				m_BillVersion1 = BcdToInt(buf[2]);
				m_BillVersion2 = BcdToInt(buf[3]);
				break;
		}
	}
}

void CsampleDlg::ParseBvcmData2(unsigned int uiInterface, char* buf)
{
	char allbytes, partbytes;
	int i;

	allbytes = buf[0];

	i = 1;
	while(i <= allbytes)
	{
		partbytes = buf[i];
		ParseBvcmData1(uiInterface, &buf[i]);
		i = i + partbytes + 1;
	}
}

int CsampleDlg::BcdToInt(unsigned char bcd)
{
	unsigned char tmp;

	tmp = ((bcd & 0xf0) >> 4) * 10;
	tmp = tmp + (bcd & 0x0f);

	return tmp;
}

unsigned char CsampleDlg::IntToBcd(int value)
{
	unsigned char tmp;
	int div, mod;

	if(value > 99) tmp = 0x99;
	else
	{
		div = value / 10;
        mod = value % 10;
		tmp = (div << 4) + mod;
	}

	return tmp;
}
